/*
  centerpos.h
  Copyright (C) 2008 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __CENTER_POS_H__
#define __CENTER_POS_H__

#include "layeredwidget.h"
#include "pos.h"

#include <qpoint.h>

class CenterPos : public LayeredWidget
{
	Q_OBJECT
  public:
	CenterPos(LayeredBase *parent = 0, const char *name = 0);
	Pos getPosition();

	bool wheelEvent( QWheelEvent *e );
	bool mouseMoveEvent( QMouseEvent *e );
    bool mousePressEvent( QMouseEvent *e );
	bool mouseReleaseEvent( QMouseEvent *e );
	bool mouseDoubleClickEvent(QMouseEvent *e);
	bool keyPressEvent ( QKeyEvent * e );
	bool paintEvent(QPaintEvent *e, QPixmap &scr);
	void showEvent();

	void timerEvent(QTimerEvent *e);

	void savePosition(int i);
	void loadPosition(int i);

  private:
	Pos center;
	QPoint click_pos;

	QPoint move_to;
	QPoint move_sum;
	int move_step;

	void scroll(int x, int y);
	void zoomup(int z);
	void jumpLocation();

	void copyPosition();
	void pastePosition();

	int move_event_counter;

	void getPHSLocation();

  public slots:
	void setPosition(Pos &pos);
	void setZoom(int zoom);

  signals:
	void positionChanged(Pos &pos);
};

#endif // __CENTER_POS_H__
