/*
  gmap.h
  Copyright (C) 2008 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __GMAP_H__
#define __GMAP_H__

#include <qwidget.h>
#include <qvbox.h>
#include <qlabel.h>

#include "map.h"
#include "qgmap.h"
#include "layeredwidget.h"
class LayeredBase;

class GMap : public LayeredWidget
{
	Q_OBJECT
  public:
	GMap( LayeredBase *parent =0, const char *name = 0);
	~GMap();
	void setMapPath(QString const &path);

	Pos getPosition();

  private:
	bool paintEvent(QPaintEvent *e, QPixmap &scr);
	void showEvent();

	int x_num;
	int y_num;

	int load_zoom;
	int load_top;
	int load_left;

	Pos center;

	Map *map;
	QPixmap offscreen;

	void loadMap(Pos loadpos);

	void scroll(int x, int y);

  public slots:
	void setPosition(Pos &);

  private slots:
	void updateCenter(bool force);
};

#endif // __GMAP_H__
