/*
  mappath.h
  Copyright (C) 2008 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __MAPPATH_H__
#define __MAPPATH_H__

#include <qobject.h>
#include <qstring.h>
#include "qgmap.h"
#include "pos.h"

class Mounter;

class MapPath : public QObject
{
	Q_OBJECT
  public:
	MapPath(QObject *parent);
	~MapPath();
	void setMapPath(int index, QString const &path);
	QString findFile(QString file);

	QString getPath(Pos &pos);

  private:
//	QObject *parent;
	QString base_path[MAXMAPPATH];
	QString mnt_path[MAXMAPPATH];

	Mounter *mounter;

	void setPath(int index, const QString &value);

  public slots:
	void setConfig(const QString &, const QString &);
};

#endif // __MAPPATH_H__
