/*
  mappathdialog.h
  Copyright (C) 2008 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __MAPPATHDIALOG_H__
#define __MAPPATHDIALOG_H__

#include <qdialog.h>
#include <qstring.h>
class QLabel;
class QPushButton;

class QListView;

class MapPathDialog : public QDialog
{ 
    Q_OBJECT

  public:
    MapPathDialog( QWidget* parent = 0, const char* name = 0, bool modal = TRUE, WFlags fl = 0 );
    ~MapPathDialog();

	typedef enum MapType {
		None,
		Dir,
		IsoImage,
		RomfsImage,
	} MapType;

//	void setMapPath(int index, MapType type, const QString &path);

//	QString getPath(int index);
//	MapType getType(int index);
	void loadConfig();
	void saveConfig();

  protected:
	QListView *listview;

	QPushButton *add_button;
	QPushButton *modify_button;
	QPushButton *del_button;
	QPushButton *up_button;
	QPushButton *down_button;

	QString getType(QString const &path);
	void addPath(QString const &path);

  public slots:
	void add_click();
	void modify_click();
	void del_click();
	void up_click();
	void down_click();

	void accept();
};

#endif // __MAPPATHDIALOG_H__
