/*
  qgconf.h
  Copyright (C) 2008 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __QGCONF_H__
#define __QGCONF_H__

#include <qobject.h>
#include <qstring.h>

#ifdef QWS
#include <qpe/config.h>
#define CONFIGCLASS Config
#else
#include <qsettings.h>
#define CONFIGCLASS QSettings
#endif // QWS

class QString;

class QGConf
: public QObject, public CONFIGCLASS
{
	Q_OBJECT
  public:
	QGConf(QObject *parent, const char *name);

	void writeEntry ( const QString & key, const char * value );
	void writeEntry ( const QString & key, const QString & value );
	void writeEntry ( const QString & key, int num );

	void reloadEntry ( const QString & key, const QString defl );
	void reloadNumEntry ( const QString & key, int defl );

	void migrate();

	void setGroup(const QString &group);

	QString group();

  private:
	QString group_name;

  signals:
	void configChanged( const QString &item, const QString &value );
};

#endif // __QGCONF_H__
