/*
  slider.h
  Copyright (C) 2008 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __SLIDER_H__
#define __SLIDER_H__

#include <qwidget.h>
#include <qpixmap.h>
#include "layeredwidget.h"

class QString;
class QPaintEvent;
class Pos;

class Slider : public LayeredWidget
{
	Q_OBJECT
  public:
	Slider( LayeredBase *parent =0, const char *name = 0);
	bool paintEvent(QPaintEvent *e, QPixmap &scr);
	bool mousePressEvent(QMouseEvent *e);
	bool mouseReleaseEvent(QMouseEvent *e);
	bool mouseMoveEvent(QMouseEvent *e);
	void showEvent();

  private:
	QPixmap slider;
	QPixmap nob;

	bool is_button;

	const QPoint slider_base;
	const QPoint nob_center;
	const QPoint slider_mul;

	int value;

	bool updateValue( int );

  public slots:
	void setPosition( Pos &pos );

  signals:
	void valueChanged( int );
};

#endif // __SLIDER_H__
